#!/bin/sh
MINSDKVERSION=21

rm -r build
rm -r install

function build() {
    ANDROID_ABI=$1
    OTHER_ARGS=$2

    BUILD_OUTDIR=build/$ANDROID_ABI
    INSTALL_PREFIX=install/$ANDROID_ABI

    cmake \
        -DCMAKE_TOOLCHAIN_FILE=$NDK/build/cmake/android.toolchain.cmake \
        -DCMAKE_BUILD_TYPE=Release \
        -DANDROID_PLATFORM=android-$MINSDKVERSION \
        -DANDROID_STL=c++_static \
        -DMEETUS_SOUNDTOUCH=ON \
        -DANDROID_ABI=$ANDROID_ABI \
        $OTHER_ARGS \
        -GNinja \
        -B $BUILD_OUTDIR || exit 1

    cmake --build $BUILD_OUTDIR --parallel || exit 1

    cmake --install $BUILD_OUTDIR --prefix $INSTALL_PREFIX || exit 1
}

# arm64-v8a
build arm64-v8a

# armeabi-v7a
build armeabi-v7a "-DANDROID_ARM_NEON=TRUE -DNEON=TRUE"

# x64
build x86_64
