#!/bin/sh
PROJECT_PATH="source/meetus_soundtouch/MeetUsSoundTouch.xcodeproj"
PROJECT_NAME=MeetUsSoundTouch
SCHEME=MeetUsSoundTouch
BUILD_DIR=./build

[ -d "${BUILD_DIR}" ] && rm -r "${BUILD_DIR}"

deviceArchivePath="${BUILD_DIR}/${PROJECT_NAME}.framework-iphoneos.xcarchive"
deviceFrameworkPath="${deviceArchivePath}/Products/Library/Frameworks/${PROJECT_NAME}.framework"
simulatorArchivePath="${BUILD_DIR}/${PROJECT_NAME}.framework-iphonesimulator.xcarchive"
simulatorFrameworkPath="${simulatorArchivePath}/Products/Library/Frameworks/${PROJECT_NAME}.framework"
xcframeworkPath="${BUILD_DIR}/${PROJECT_NAME}.xcframework"
frameworkPath="${BUILD_DIR}/${PROJECT_NAME}.framework"

xcodebuild archive \
-project "${PROJECT_PATH}" \
-scheme "${SCHEME}" \
-configuration Release \
-destination 'generic/platform=iOS' \
-archivePath "${deviceArchivePath}" \
SKIP_INSTALL=NO \
BUILD_LIBRARIES_FOR_DISTRIBUTION=YES

xcodebuild archive \
-project "${PROJECT_PATH}" \
-scheme "${SCHEME}" \
-configuration Release \
-destination 'generic/platform=iOS Simulator' \
-archivePath "${simulatorArchivePath}" \
SKIP_INSTALL=NO \
BUILD_LIBRARIES_FOR_DISTRIBUTION=YES

### xcframework
xcodebuild -create-xcframework \
-framework "${deviceFrameworkPath}" \
-framework "${simulatorFrameworkPath}" \
-output "${xcframeworkPath}"

### fat framework

# prepare
cp -R "${deviceFrameworkPath}" "${frameworkPath}"

# remove arm64 from the simulator build
simulatorBinary="${BUILD_DIR}${PROJECT_NAME}-simulator"

lipo -remove arm64 "${simulatorFrameworkPath}/${PROJECT_NAME}" \
-output "${simulatorBinary}"

# create fat
fatBinary="${BUILD_DIR}/${PROJECT_NAME}" 

lipo -create -output "${fatBinary}" \
"${deviceFrameworkPath}/${PROJECT_NAME}" \
"${simulatorBinary}"

# replace an original binary with just created one
cp "${fatBinary}" "${frameworkPath}"

# update Info.plist
/usr/libexec/PlistBuddy -c "Add :CFBundleSupportedPlatforms: string iPhoneSimulator" "${frameworkPath}/Info.plist"

